// -*- mode: c++ -*-

#ifndef MIX_COMMENT_H_
#define MIX_COMMENT_H_

#include "classes.h"
#include "misc.h"
#include "XMLString.h"
#include "NodeList.h"
#include "Value.h"

namespace MiX{
  ///XMLɥΥȤɽ饹Ǥ
  template <class Char,class Traits,class XMLTraits>
  class Comment : public Value<Char,Traits,XMLTraits>{
  public:
    MiX_Template_Typedef(Char,Traits,XMLTraits);
    typedef Comment<Char,Traits,XMLTraits> this_type;
    typedef NodeContainer<Char,Traits,XMLTraits> nodecontainer_type;
  private:
    const static nodelist_type::iterator dmy_it;
  protected:
    /**
     * 󥹥ȥ饯.
     *
     * CommentΥ󥹥ȥ饯ľܸƤ٤ޤ<br>
     * Comment<...>::createƤ
     */
    Comment(const string_type& val)
      : Value<Char,Traits,XMLTraits>(val) { };
    /**
     * ԡ󥹥ȥ饯
     *
     * CommentϥԡǤޤ
     */
    Comment(const Comment<Char,Traits,XMLTraits>& src){ };

  public:
    ///ǥȥ饯
    virtual ~Comment()throw() { };
    ///ΥΡɤΥפޤ
    virtual NodeType getType()const { return Node_Comment; };
    /**
     * Ū˥饹NodeTypeޤ
     *
     * Node_Comment֤ޤ
     */
    static NodeType type() { return Node_Comment; } ;
    /**
     * Commentʸɽޤ
     *
     * bIndentʤʸiIndentOffset˻ꤵ줿
     * XMLTraits::tab()ͤƬˤĤޤ
     */
    virtual string_type toString(bool is_indent=false,int indent_off=0)const;
    /**
     * Commentޤ
     *
     * <dl>
     *   <dt>str</dt><dd>Comment</dd>
     *   <dt>parent</dt><dd>Commentοƥ</dd>
     *   <dt>it</dt><dd>parent.getChilds()Ǥ򼨤ƥ졼ǤʤФʤޤ</dd>
     * </dl>
     */
    static this_type& create(const string_type& str,element_type& parent,const typename nodelist_type::iterator& it = dmy_it);

    friend class DOM_Parser<Char,Traits,XMLTraits>;
  };
}

#ifndef MIX_COMMENT_CPP_
#include "Comment.cpp"
#endif//MIX_COMMENT_CPP_

#endif
