// -*- mode: c++ -*-

#ifndef MIX_SAX_EVENTHANDLER_H_
#define MIX_SAX_EVENTHANDLER_H_

#include "classes.h"
#include "misc.h"
#include "Tokenizer.h"

#include "XMLString.h"
#include "AttrMap.h"

namespace MiX{
  /**
   * SaxParserΥ٥Τ륤󥿥ե
   *
   * Ѿƥ٥ȥϥɥ
   * ǥեưǤonExceptionʳ⤷ʤ
   * onExceptionϥǥեư㳰ꤲ
   */
  template <class Char,class Traits,class XMLTraits>
  class SAX_EventHandler{
  public:
    /**
     * XML(<?xml...?>)򸡽Ф˸ƤФ
     *
     * <dl>
     * <dd>attr</dd><dt>XMLͿ줿ѥ᡼ǼAttrMap</dt>
     * </dl>
     */
    virtual void onXMLDeclaration(AttrMap<Char,Traits,XMLTraits> attr){}
    /**
     * λϤޤ򸡽Ф˸ƤФ
     *
     * <dl>
     *   <dt>sName</dt><dd>̾</dd>
     *   <dt>attr</dt><dd>Ϳ줿ѥ᡼ǼAttrMap</dd>
     * </dl>
     */
    virtual void onStart(XMLString<Char,Traits,XMLTraits> sName,
			 AttrMap<Char,Traits,XMLTraits> attr){ };
    /**
     * ν򸡽Ф˸ƤФ
     *
     * λά(<hoge/>)ǤƤФޤ
     * <dl><dt>sName</dt><dd>̾</dd></dl>
     */
    virtual void onEnd(XMLString<Char,Traits,XMLTraits> sName){ };
    /**
     * ̤ʸ򸡽Ф˸ƤФ
     *
     *  <dl><dt>sText</dt><dd>ʸ</dd></dl>
     */
    virtual void onText(XMLString<Char,Traits,XMLTraits> sText){ };
    /**
     * Ȥ򸡽Ф˸ƤФ
     * <dl><dt>sText</dt><dd></dd></dl>
     */
    virtual void onComment(XMLString<Char,Traits,XMLTraits> sText){};
    /**
     * 㳰ä˸ƤФ
     *
     * ͤϲϤߤ뤫ɤ
     * (֤硢parse᥽åɤfalse֤ƽλ)
     *  <dl><dt>e</dt><dd>㳰֥</dd></dl>
     */
    virtual bool onException(ParsingException e);
  };
}

#ifndef MIX_SAX_EVENTHANDLER_CPP_
#include "SAX_EventHandler.cpp"
#endif

#endif 
