// -*- mode: c++ -*-

#ifndef MIX_TEXT_H_
#define MIX_TEXT_H_

#include "classes.h"
#include "misc.h"
#include "XMLString.h"
#include "NodeList.h"

namespace MiX{
  ///XMLɥʸ򤢤魯饹Ǥ
  template <class Char,class Traits,class XMLTraits>
  class Text : public Value<Char,Traits,XMLTraits>{
  public:
    MiX_Template_Typedef(Char,Traits,XMLTraits);
    typedef Element<Char,Traits,XMLTraits> this_type;
    typedef NodeContainer<Char,Traits,XMLTraits> nodecontainer_type;
  protected:
    const static NodeList<Char,Traits,XMLTraits>::iterator dmy_it;
    /**
     * 󥹥ȥ饯
     *
     * TextΥ󥹥ȥ饯ľܸƤ٤ޤ<br>
     * Text<...>::createƤ
     */
    Text(const XMLString<Char,Traits,XMLTraits>& val)
      : Value<Char,Traits,XMLTraits>(val){ };
    /**
     * ԡ󥹥ȥ饯
     *
     * TextϥԡǤޤ
     */
    Text(const Text<Char,Traits,XMLTraits>& src){ };
  public:
    ///ǥȥ饯
    virtual ~Text()throw(){ };
    ///ΥΡɤΥפޤ
    virtual NodeType getType()const{ return Node_Text; };
    /**
     * Ū˥饹NodeTypeޤ
     *
     * Node_Text֤ޤ
     */
    static NodeType type(){ return Node_Text; };
    /**
     * Textʸɽޤ
     *
     * bIndentʤʸiIndentOffset˻ꤵ줿
     * XMLTraits::tab()ͤƬˤĤޤ
     */
    virtual XMLString<Char,Traits,XMLTraits> toString(bool indent=false,int indent_off=0)const;
    /**
     * Textޤ
     *
     * <dl>
     *   <dt>str</dt><dd>Text</dd>
     *   <dt>parent</dt><dd>Textοƥ</dd>
     *   <dt>it</dt><dd><br>
     *        parent.getChilds()Ǥ򼨤ƥ졼ǤʤФʤޤ</dd>
     * </dl>
     */
    static Text<Char,Traits,XMLTraits>& create(const XMLString<Char,Traits,XMLTraits>& str,Element<Char,Traits,XMLTraits>& parent,const typename NodeList<Char,Traits,XMLTraits>::iterator& it = dmy_it);

    friend class DOM_Parser<Char,Traits,XMLTraits>;
  };
}

#ifndef MIX_TEXT_CPP_
#include "Text.cpp"
#endif

#endif
