// -*- mode: c++ -*-
#ifndef MIX_CLASSES_H_
#define MIX_CLASSES_H_

#include "config.h"
#include <string>

/**
 * MiXǻѤ륯饹̾
 */
namespace MiX{
  template <class Char,
	    class Traits = MiX_DEFAULT_TRAITS<Char> > 
  class DefaultXMLTraits;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class XMLString;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class AttrMap;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class NodeList;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class SAX_EventHandler;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class XMLToken;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Tokenizer;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class SAX_Parser;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class DOM_Parser;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Node;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class NodeContainer;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class NamedNode;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Value;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Document;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Element;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> > 
  class Attribute;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class Text;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class Comment;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class DomException;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class NodeNameChecker;
  
  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class NodeTypeChecker;

  template <class Char,class Traits = MiX_DEFAULT_TRAITS<Char>,
	    class XMLTraits = DefaultXMLTraits<Char,Traits> >
  class NamedNodeFinder;

  class ParsingException;  
}

// ǥ󥰤ñˤ뤿Υꥢ
/*
namespace MiX_UTF8{
  typedef MiX::DefaultXMLTraits<MiX::UTF8_Char> DefaultXMLTraits;
  typedef MiX::XMLString<MiX::UTF8_Char> XMLString;
  typedef MiX::AttrMap<MiX::UTF8_Char> AttrMap;
  typedef MiX::NodeList<MiX::UTF8_Char> NodeList;
  typedef MiX::SaxEventHandler<MiX::UTF8_Char> SaxEventHandler;
  typedef MiX::XMLToken<MiX::UTF8_Char> XMLToken;
  typedef MiX::Tokenizer<MiX::UTF8_Char> Tokenizer;
  typedef MiX::SaxParser<MiX::UTF8_Char> SaxParser;
  typedef MiX::DomParser<MiX::UTF8_Char> DomParser;
  typedef MiX::Node<MiX::UTF8_Char> Node;
  typedef MiX::NodeContainer<MiX::UTF8_Char> NodeContainer;
  typedef MiX::NamedNode<MiX::UTF8_Char> NamedNode;
  typedef MiX::Value<MiX::UTF8_Char> Value;
  typedef MiX::Document<MiX::UTF8_Char> Document;
  typedef MiX::Element<MiX::UTF8_Char> Element;
  typedef MiX::Attribute<MiX::UTF8_Char> Attribute;
  typedef MiX::Text<MiX::UTF8_Char> Text;
  typedef MiX::Comment<MiX::UTF8_Char> Comment;
  typedef MiX::DomException<MiX::UTF8_Char> DomException;
  typedef MiX::ParsingException ParsingException;
}
namespace MiX_UTF16{
  typedef MiX::DefaultXMLTraits<MiX::UTF16_Char> DefaultXMLTraits;
  typedef MiX::XMLString<MiX::UTF16_Char> XMLString;
  typedef MiX::AttrMap<MiX::UTF16_Char> AttrMap;
  typedef MiX::NodeList<MiX::UTF16_Char> NodeList;
  typedef MiX::SaxEventHandler<MiX::UTF16_Char> SaxEventHandler;
  typedef MiX::XMLToken<MiX::UTF16_Char> XMLToken;
  typedef MiX::Tokenizer<MiX::UTF16_Char> Tokenizer;
  typedef MiX::SaxParser<MiX::UTF16_Char> SaxParser;
  typedef MiX::DomParser<MiX::UTF16_Char> DomParser;
  typedef MiX::Node<MiX::UTF16_Char> Node;
  typedef MiX::NodeContainer<MiX::UTF16_Char> NodeContainer;
  typedef MiX::NamedNode<MiX::UTF16_Char> NamedNode;
  typedef MiX::Value<MiX::UTF16_Char> Value;
  typedef MiX::Document<MiX::UTF16_Char> Document;
  typedef MiX::Element<MiX::UTF16_Char> Element;
  typedef MiX::Attribute<MiX::UTF16_Char> Attribute;
  typedef MiX::Text<MiX::UTF16_Char> Text;
  typedef MiX::Comment<MiX::UTF16_Char> Comment;
  typedef MiX::DomException<MiX::UTF16_Char> DomException;
  typedef MiX::ParsingException ParsingException;
}
*/
#endif
